// CListCtrlExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CListCtrlExample.h"
#include "CListCtrlExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCListCtrlExampleDlg dialog

CCListCtrlExampleDlg::CCListCtrlExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCListCtrlExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCListCtrlExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCListCtrlExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCListCtrlExampleDlg)
	DDX_Control(pDX, IDC_LIST4, m_list4);
	DDX_Control(pDX, IDC_LIST3, m_list3);
	DDX_Control(pDX, IDC_LIST2, m_list2);
	DDX_Control(pDX, IDC_LIST1, m_list1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCListCtrlExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CCListCtrlExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCListCtrlExampleDlg message handlers

BOOL CCListCtrlExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//At first we hide the scrollbars...
	//Note: The ClientArena style of hiding scrollbars must be added BEFORE! the ListCtrl is filled!
	m_list1.HideScrollBars(LCSB_CLIENTDATA, SB_VERT);
	m_list2.HideScrollBars(LCSB_CLIENTDATA);
	m_list3.HideScrollBars(LCSB_NCOVERRIDE);
	m_list4.HideScrollBars(LCSB_NCOVERRIDE);

	//Filling each listctrl...
	m_list2.InsertColumn(0,"Col 1",LVCFMT_LEFT,100);
	m_list2.InsertColumn(1,"Col 2",LVCFMT_LEFT,100);
	m_list2.InsertColumn(2,"Col 3",LVCFMT_LEFT,100);
	m_list2.InsertColumn(3,"Col 4",LVCFMT_LEFT,100);
	m_list2.InsertColumn(4,"Col 5",LVCFMT_LEFT,100);
	m_list4.InsertColumn(0,"Col 1",LVCFMT_LEFT,100);
	m_list4.InsertColumn(1,"Col 2",LVCFMT_LEFT,100);
	m_list4.InsertColumn(2,"Col 3",LVCFMT_LEFT,100);
	m_list4.InsertColumn(3,"Col 4",LVCFMT_LEFT,100);
	m_list4.InsertColumn(4,"Col 5",LVCFMT_LEFT,100);
	
	CString Text;
	
	for(int i=0;i<100;i++)
	{
		Text.Format("Data %i",i);
		m_list1.InsertItem(i,Text);
		m_list2.InsertItem(i,Text);
		m_list2.SetItemText(i,1,Text);
		m_list2.SetItemText(i,2,Text);
		m_list2.SetItemText(i,3,Text);
		m_list2.SetItemText(i,4,Text);
		m_list4.InsertItem(i,Text);
		m_list4.SetItemText(i,1,Text);
		m_list4.SetItemText(i,2,Text);
		m_list4.SetItemText(i,3,Text);
		m_list4.SetItemText(i,4,Text);
		m_list3.InsertItem(i,Text);
	}

	//Set extended styles to make it look better! :)
	m_list2.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_list4.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCListCtrlExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCListCtrlExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCListCtrlExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//****************************************************************************************

void CCListCtrlExampleDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK(); //Just to override so ENTER does not quit
}

void CCListCtrlExampleDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

//****************************************************************************************
